using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Autoscribe.Lyons.GeneralService;
using Autoscribe.Lyons.ATMService;
using atmDemo.Wrapper;
using System.Configuration;

namespace atmDemo
{
    class demoService
    {
        public const string CFG_LOGON_USERNAME = "userName";
        public const string CFG_LOGON_COMPANYID = "companyID";
        public const string CFG_LOGON_PASSWORD = "userPassword";
        // Test Data
        public const string CFG_TEST_ABA = "demoABA";
        public const string CFG_TEST_ACCOUNT = "demoAccount";
        public const string CFG_TEST_AMOUNT = "demoAmount";
        public const string CFG_TEST_PRESENT = "demoPresent";
        public const string CFG_TEST_DENYNSF = "demoDenyNsf";

        private IATMServiceWrapper atmSvc = new ATMServiceWrapper();
        public string GetAppSetting(string key)
        {
            string res = null;
            try
            {
                res = ConfigurationManager.AppSettings.Get(key);
            }
            catch { }
            return res;
        }

        public bool GetFullStatusReport()
        {
            bool status = false;
            string userName = GetAppSetting(CFG_LOGON_USERNAME);
            string password = GetAppSetting(CFG_LOGON_PASSWORD);
            int companyId = Int32.Parse(GetAppSetting(CFG_LOGON_COMPANYID));
            string aba = GetAppSetting(CFG_TEST_ABA);
            string account = GetAppSetting(CFG_TEST_ACCOUNT);
            string amount = GetAppSetting(CFG_TEST_AMOUNT);
            string present = GetAppSetting(CFG_TEST_PRESENT);
            string denyNsf = GetAppSetting(CFG_TEST_DENYNSF);

            try
            {
                string token = atmSvc.Logon(companyId, userName, password).Token;

                // Check IsParticipant
                BooleanResult isParticipantTest = atmSvc.IsParticipant(token, aba);
                if(isParticipantTest != null && isParticipantTest.ErrorMesssage == null)
                    Console.WriteLine(String.Format("IsParticipant: {0} aba is {1}", aba, isParticipantTest.Value));
                else
                    Console.WriteLine(String.Format("IsParticipant: {0} has an error {1}", aba, isParticipantTest.ErrorMesssage));

                // Verify Account
                StatusCodeResult verifyAccountTest = atmSvc.VerifyAccount(token, aba, account, amount, present);
                if (verifyAccountTest != null && verifyAccountTest.ErrorMesssage == null)
                    Console.WriteLine(String.Format("VerifyAccount: (aba: {0}, account: {1}, amount:{2}, present:{3}) status code {4}", aba, account, amount, present, verifyAccountTest.StatusCode));
                else
                    Console.WriteLine(String.Format("VerifyAccount: {0} has an error {1}", aba, verifyAccountTest.ErrorMesssage));

                // Describe Satatus Code
                StatusDescriptionResult describeStatusCodeTest = atmSvc.DescribeStatusCode(token, verifyAccountTest.StatusCode);
                if (describeStatusCodeTest != null && describeStatusCodeTest.ErrorMesssage == null)
                    Console.WriteLine(String.Format("DescribeStatusCode: (statusCode:{0}) description: {1}", describeStatusCodeTest.StatusCode, describeStatusCodeTest.StatusDescription));
                else
                    Console.WriteLine(String.Format("DescribeStatusCode: {0} has an error {1}", aba, describeStatusCodeTest.ErrorMesssage));

                // Verify Account With Details
                DetailedStatusCodeResult verifyAccountWithDetailsTest = atmSvc.VerifyAccountWithDetails(token, aba, account, amount, present, denyNsf);
                if (verifyAccountWithDetailsTest != null && verifyAccountWithDetailsTest.ErrorMesssage == null)
                    Console.WriteLine(String.Format("VerifyAccountWithDetails: (aba: {0}, account: {1}, amount:{2}, present:{3}, denyNsf:{4}) {5} | {6}", aba, account, amount, present, denyNsf, verifyAccountWithDetailsTest.PrimaryInstitution.Name, verifyAccountWithDetailsTest.PrimaryInstitution.State));
                else
                    Console.WriteLine(String.Format("VerifyAccountWithDetails: {0} has an error {1}", aba, verifyAccountWithDetailsTest.ErrorMesssage));

                atmSvc.Logoff(token);
                return true;
            }
            catch(Exception ex)
            {
                string err = ex.Message;
            }
            return false;
        }
    }
}
